Index: libcfs/include/libcfs/libcfs_debug.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_debug.h,v
retrieving revision 1.12
diff -u -p -r1.12 libcfs_debug.h
--- libcfs/include/libcfs/libcfs_debug.h	15 Sep 2009 17:52:18 -0000	1.12
+++ libcfs/include/libcfs/libcfs_debug.h	1 Jan 2010 20:03:31 -0000
@@ -42,6 +42,11 @@
 #ifndef __LIBCFS_DEBUG_H__
 #define __LIBCFS_DEBUG_H__
 
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_debug
+ * @{ */
+
 /*
  *  Debugging
  */
@@ -68,6 +73,75 @@ extern unsigned int libcfs_catastrophe;
 extern unsigned int libcfs_panic_on_lbug;
 
 /**
+ * \defgroup libcfs_debug_print Debug printing
+ * Generic API to print debug messages
+ *
+ * The API for printing debug messages includes the following macros:
+ * - CDEBUG
+ * - CWARN
+ * - CERROR
+ * - LCONSOLE
+ * - LCONSOLE_INFO
+ * - LCONSOLE_WARN
+ * - LCONSOLE_ERROR_MSG
+ * - LCONSOLE_ERROR
+ * - LCONSOLE_EMERG
+ *
+ * These macros may print a message to internal log buffers provided
+ * by tracefile subsystem when used in kernel or to a file which name
+ * is specified in LIBLUSTRE_DEBUG_FILE environment variable in
+ * user-space case. They also may print out the message on the
+ * console. Making decision about printing particular message depends
+ * on the notions of \a mask and \a subsystem.
+ *
+ * \a subsystem represents a logical part of Lustre. For example,
+ * S_LNET for LNET subsystem, S_LDLM for LDLM, etc. Internally, \a
+ * subsystem is a combination of bit-flags S_MDC, S_MDS, and many
+ * others (see "Debugging subsystems" in libcfs_debug.h). The caller
+ * must define c-preprocessor variable DEBUG_SUBSYSTEM with desired
+ * \a subsystem before calling any debug print macro. Typically, such
+ * a define comes in the beginning of each c-file.
+ *
+ * \a mask represents an "area of interest" like warnings, errors,
+ * ioctl-related events etc. Internally, \a mask is a combination of
+ * bit-flags D_TRACE, D_INODE, and many others (see "Debugging masks"
+ * in libcfs_debug.h). In case of CDEBUG and LCONSOLE macros, the
+ * caller specifies \a mask explicitly, as the first argument of
+ * macro. In other cases, \a masks are predefined like D_WARNING for
+ * CWARN macro, D_ERROR for CERROR macro, etc.
+ *
+ * D_CONSOLE flag is reserved for indicating the fact that given debug
+ * print should appears on the console. LCONSOLE macro adds this flag
+ * to caller-supplied \a mask to ensure printing on console.
+ 
+ * Typically, all macros from the list above (excepting CDEBUG) print
+ * the message on console as well as in internal memory buffers. This
+ * behavior may be changed by tuning global variable \a libcfs_printk.
+ * This variable is a \a mask consisting of the flags for which
+ * console printing is desired.
+ *
+ * As for CDEBUG, Libcfs firstly makes decision whether given debug
+ * print should be printed at all. The decision is  based on \a mask
+ * and \a subsystem (see implementation of cdebug_show). If the
+ * decision is positive, the debug print always goes into internal log
+ * buffers and optionally may appear on console. Console print happens
+ * if the caller used \a mask (as its first argument) containing any
+ * flags from libcfs_printk.
+ *
+ * All of debug print APIs excepting CDEBUG and LCONSOLE are
+ * rate-limited. This means that Libcfs skips console printing for
+ * them if the same macro is invoked from the same line of code too
+ * often. The delay varies from \a libcfs_console_min_delay to
+ * \a libcfs_console_max_delay adaptively. User can disable this feature
+ * by setting global variable \a libcfs_console_ratelimit to zero.
+ *
+ * NOTE: In user-space case, console printing and rate-limiting are
+ * only available when header-file named "catamount/data.h" is present
+ * while building Lustre.
+ * @{
+ */
+
+/**
  * Format for debug message headers
  */
 struct ptldebug_header {
@@ -239,6 +313,8 @@ do {                                    
 
 #define LCONSOLE_EMERG(format, ...) CDEBUG(D_CONSOLE | D_EMERG, format, ## __VA_ARGS__)
 
+/** @} libcfs_debug_print */
+
 #ifdef CDEBUG_ENABLED
 
 #define GOTO(label, rc)                                                 \
@@ -304,6 +380,9 @@ do {                                    
         return;                                                         \
 } while (0)
 
+/** \addtogroup libcfs_debug_print
+ * @{ */
+
 struct libcfs_debug_msg_data {
         cfs_debug_limit_state_t *msg_cdls;
         int                      msg_subsys;
@@ -350,14 +429,6 @@ extern int libcfs_debug_vmsg2(cfs_debug_
                                  (file), (func), (line), fmt, ## __VA_ARGS__);\
 } while(0)
 
-extern void libcfs_assertion_failed(const char *expr, const char *file,
-                                    const char *fn, const int line);
-
-/* one more external symbol that tracefile provides: */
-extern int trace_copyout_string(char *usr_buffer, int usr_buffer_nob,
-                                const char *knl_buffer, char *append);
-
-
 #if defined(HAVE_BGL_SUPPORT)
 #define DEBUG_FILE_PATH_DEFAULT "/bgl/ion/tmp/lustre-log"
 #elif defined(__arch_um__)
@@ -368,4 +439,16 @@ extern int trace_copyout_string(char *us
 #define DEBUG_FILE_PATH_DEFAULT "/tmp/lustre-log"
 #endif
 
+/** @} libcfs_debug_print */
+
+extern void libcfs_assertion_failed(const char *expr, const char *file,
+                                    const char *fn, const int line);
+
+/* one more external symbol that tracefile provides: */
+extern int trace_copyout_string(char *usr_buffer, int usr_buffer_nob,
+                                const char *knl_buffer, char *append);
+
+/** @} libcfs_debug */
+/** @} libcfs */
+
 #endif	/* __LIBCFS_DEBUG_H__ */
Index: libcfs/include/libcfs/libcfs_hash.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_hash.h,v
retrieving revision 1.4
diff -u -p -r1.4 libcfs_hash.h
--- libcfs/include/libcfs/libcfs_hash.h	1 Dec 2009 02:23:43 -0000	1.4
+++ libcfs/include/libcfs/libcfs_hash.h	1 Jan 2010 20:03:32 -0000
@@ -41,6 +41,45 @@
 
 #ifndef __LIBCFS_HASH_H__
 #define __LIBCFS_HASH_H__
+
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup hash_table Hash table
+ * An abstraction layer over 'hash table' technique
+ *
+ * Libcfs Hashing provides an abstraction layer over well-known 'hash
+ * table' technique that uses a hash function to efficiently map
+ * certain identifiers or keys to associated values. The key point is
+ * maintaining an array of 'buckets' where each bucket chains the list
+ * of items stored in hash table and using some hash function 'f' to
+ * locate proper slot in the array like this: index = f(key, array_length).
+ *
+ * A consumer should provide the following prerequisites to use this facility:
+ * - a storage for hlist_node for each item (usually embedded into
+ * item's data structure)
+ * - some descriptive name for the given hash table
+ * - initial and maximum allowed hash table sizes
+ * - a function calculating key for given item
+ * - hash function suitable for given distribution of keys
+ * - 'compare' function determining whether given item has given key
+ * - get/put functions converting pointer to hlist_node of item to the
+ * pointer to the whole item (can also be used to update reference
+ * counter of item)
+ * - optional exit function that will be called for every item after
+ * its removal from hash table while its destruction.
+ *
+ * Having all bits listed above provided, libcfs hash subsystem allows:
+ * - create and destroy hash table
+ * - add, delete and lookup entries in hash table
+ * - rehash item if its key was changed
+ * - print out internal hash table parameters for debug purposes
+ * - dynamic rehashing (i.e. rebuilding hash table to keep load factor
+ * low)
+ * @{
+ */
+
 /*
  * Knuth recommends primes in approximately golden ratio to the maximum
  * integer representable by a machine word for multiplicative hashing.
@@ -51,9 +90,9 @@
  * them can use shifts and additions instead of multiplications for
  * machines where multiplications are slow.
  */
-/* 2^31 + 2^29 - 2^25 + 2^22 - 2^19 - 2^16 + 1 */
+/** 2^31 + 2^29 - 2^25 + 2^22 - 2^19 - 2^16 + 1 */
 #define CFS_GOLDEN_RATIO_PRIME_32 0x9e370001UL
-/*  2^63 + 2^61 - 2^57 + 2^54 - 2^51 - 2^18 + 1 */
+/**  2^63 + 2^61 - 2^57 + 2^54 - 2^51 - 2^18 + 1 */
 #define CFS_GOLDEN_RATIO_PRIME_64 0x9e37fffffffc0001ULL
 
 /*
@@ -70,10 +109,10 @@
    (C) 2002 William Lee Irwin III, IBM */
 
 #if BITS_PER_LONG == 32
-/* 2^31 + 2^29 - 2^25 + 2^22 - 2^19 - 2^16 + 1 */
+/** 2^31 + 2^29 - 2^25 + 2^22 - 2^19 - 2^16 + 1 */
 #define CFS_GOLDEN_RATIO_PRIME          CFS_GOLDEN_RATIO_PRIME_32
 #elif BITS_PER_LONG == 64
-/*  2^63 + 2^61 - 2^57 + 2^54 - 2^51 - 2^18 + 1 */
+/**  2^63 + 2^61 - 2^57 + 2^54 - 2^51 - 2^18 + 1 */
 #define CFS_GOLDEN_RATIO_PRIME          CFS_GOLDEN_RATIO_PRIME_64
 #else
 #error Define CFS_GOLDEN_RATIO_PRIME for your wordsize.
@@ -118,41 +157,86 @@ static inline unsigned long hash_ptr(voi
 
 struct cfs_hash_ops;
 
+/**
+ * Represents the chain of items producing the same hash_func value
+ */
 typedef struct cfs_hash_bucket {
-        struct hlist_head           hsb_head;       /* entries list */
-        atomic_t                    hsb_count;      /* current entries */
-        rwlock_t                    hsb_rwlock;     /* cfs_hash_bucket */
+        /** entries list */
+        struct hlist_head           hsb_head;
+        /** # current entries */
+        atomic_t                    hsb_count;
+        /** protects operations on given bucket */
+        rwlock_t                    hsb_rwlock;
 } cfs_hash_bucket_t;
 
 #define CFS_MAX_HASH_NAME 16
 
+/**
+ * Libcfs hash table. Essentially, is array of buckets along with some
+ * bits of information necessary to maintain it.
+ */
 typedef struct cfs_hash {
-        int                         hs_cur_bits;    /* current hash bits */
-        int                         hs_cur_mask;    /* current hash mask */
-        int                         hs_min_bits;    /* min hash bits */
-        int                         hs_max_bits;    /* max hash bits */
-        int                         hs_min_theta;   /* resize min threshold */
-        int                         hs_max_theta;   /* resize max threshold */
-        int                         hs_flags;       /* hash flags */
-        atomic_t                    hs_count;       /* current entries */
-        atomic_t                    hs_rehash_count;/* resize count */
-        struct cfs_hash_bucket    **hs_buckets;     /* hash buckets */
-        struct cfs_hash_ops        *hs_ops;         /* hash operations */
-        rwlock_t                    hs_rwlock;      /* cfs_hash */
+        /** current hash bits */
+        int                         hs_cur_bits;
+        /** current hash mask */
+        int                         hs_cur_mask;
+        /** min hash bits */
+        int                         hs_min_bits;
+        /** max hash bits */
+        int                         hs_max_bits;
+        /** resize min threshold */
+        int                         hs_min_theta;
+        /** resize max threshold */
+        int                         hs_max_theta;
+        /** hash flags */
+        int                         hs_flags;
+        /** # current entries */
+        atomic_t                    hs_count;
+        /** resize count */
+        atomic_t                    hs_rehash_count;
+        /** hash buckets */
+        struct cfs_hash_bucket    **hs_buckets;
+        /** hash operations */
+        struct cfs_hash_ops        *hs_ops;
+        /** protects fields of cfs_hash while rehashing */
+        rwlock_t                    hs_rwlock;
+        /** some descriptive name of this hash */
         char                        hs_name[CFS_MAX_HASH_NAME];
 } cfs_hash_t;
 
+/** Consumer-supplied operations specific for given hash table */
 typedef struct cfs_hash_ops {
+        /** hash function operating on \a key */
         unsigned (*hs_hash)(cfs_hash_t *hs, void *key, unsigned mask);
+        /** calculates \a key for item represented by \a hnode */
         void *   (*hs_key)(struct hlist_node *hnode);
+        /**
+         * checks whether item correspondent to \a hnode has key
+         * equal to \a key
+         */
         int      (*hs_compare)(void *key, struct hlist_node *hnode);
+        /**
+         * Converts \a hnode to item pointer.
+         * Also, hints consumer that the item is in use.
+         */
         void *   (*hs_get)(struct hlist_node *hnode);
+        /**
+         * Converts \a hnode to item pointer.
+         * Also, hints consumer that the item isn't in use anymore.
+         */
         void *   (*hs_put)(struct hlist_node *hnode);
+        /**
+         * optional; will be called for every item after its removal
+         * from hash table while its destruction
+         */
         void     (*hs_exit)(struct hlist_node *hnode);
 } cfs_hash_ops_t;
 
-#define CFS_HASH_DEBUG          0x0001  /* Enable expensive debug checks */
-#define CFS_HASH_REHASH         0x0002  /* Enable dynamic hash resizing */
+/** Enable expensive debug checks */
+#define CFS_HASH_DEBUG          0x0001
+
+/** Enable dynamic hash resizing */
+#define CFS_HASH_REHASH         0x0002
 
 #define CFS_HO(hs)             (hs)->hs_ops
 #define CFS_HOP(hs, op)        (hs)->hs_ops->hs_ ## op
@@ -180,7 +264,12 @@ cfs_hash_key(cfs_hash_t *hs, struct hlis
         return NULL;
 }
 
-/* Returns 1 on a match,
+/**
+ * Check whether the element correspondent to \a hnode has
+ * key equal to \a key
+ *
+ * \return 1 on a match, 0 otherwise.
+ *
  * XXX: This would be better if it returned, -1, 0, or 1 for
  *      <, =, > respectivly.  It could then be used to implement
  *      a CFS_HASH_SORT feature flags which could keep each hash
@@ -239,7 +328,7 @@ cfs_hash_exit(cfs_hash_t *hs, struct hli
                 return CFS_HOP(hs, exit)(hnode);
 }
 
-/* Validate hnode references the correct key */
+/** Validate hnode references the correct key */
 static inline void
 __cfs_hash_key_validate(cfs_hash_t *hs, void *key,
                         struct hlist_node *hnode)
@@ -248,7 +337,7 @@ __cfs_hash_key_validate(cfs_hash_t *hs, 
                 LASSERT(cfs_hash_compare(hs, key, hnode) > 0);
 }
 
-/* Validate hnode is in the correct bucket */
+/** Validate hnode is in the correct bucket */
 static inline void
 __cfs_hash_bucket_validate(cfs_hash_t *hs, cfs_hash_bucket_t *hsb,
                            struct hlist_node *hnode)
@@ -300,25 +389,40 @@ __cfs_hash_bucket_del(cfs_hash_t *hs,
         return cfs_hash_put(hs, hnode);
 }
 
-/* Hash init/cleanup functions */
+/**
+ *\defgroup hash_init_fini Hash init/cleanup functions
+ * @{
+ */
 cfs_hash_t *cfs_hash_create(char *name, unsigned int cur_bits,
                             unsigned int max_bits,
                             cfs_hash_ops_t *ops, int flags);
 void cfs_hash_destroy(cfs_hash_t *hs);
+/** @} */
 
-/* Hash addition functions */
+/**
+ *\defgroup hash_adds Hash addition functions
+ * @{
+ */
 void cfs_hash_add(cfs_hash_t *hs, void *key,
                   struct hlist_node *hnode);
 int cfs_hash_add_unique(cfs_hash_t *hs, void *key,
                         struct hlist_node *hnode);
 void *cfs_hash_findadd_unique(cfs_hash_t *hs, void *key,
                               struct hlist_node *hnode);
+/** @} */
 
-/* Hash deletion functions */
+/**
+ *\defgroup hash_del Hash deletion functions
+ * @{
+ */
 void *cfs_hash_del(cfs_hash_t *hs, void *key, struct hlist_node *hnode);
 void *cfs_hash_del_key(cfs_hash_t *hs, void *key);
+/** @} */
 
-/* Hash lookup/for_each functions */
+/**
+ *\defgroup hash_lookup Hash lookup/for_each functions
+ * @{
+ */
 void *cfs_hash_lookup(cfs_hash_t *hs, void *key);
 typedef void (*cfs_hash_for_each_cb_t)(void *obj, void *data);
 void cfs_hash_for_each(cfs_hash_t *hs, cfs_hash_for_each_cb_t, void *data);
@@ -326,25 +430,30 @@ void cfs_hash_for_each_safe(cfs_hash_t *
 void cfs_hash_for_each_empty(cfs_hash_t *hs, cfs_hash_for_each_cb_t, void *data);
 void cfs_hash_for_each_key(cfs_hash_t *hs, void *key,
                            cfs_hash_for_each_cb_t, void *data);
+/** @} */
 
-/*
+/**
+ *\defgroup hash_rehash Hash rehash functions
+ *
  * Rehash - Theta is calculated to be the average chained
- * hash depth assuming a perfectly uniform hash funcion.
+ * hash depth assuming a perfectly uniform hash function.
+ * @{
  */
 int cfs_hash_rehash(cfs_hash_t *hs, int bits);
 void cfs_hash_rehash_key(cfs_hash_t *hs, void *old_key,
                          void *new_key, struct hlist_node *hnode);
+/** @} */
 
 
 #define CFS_HASH_THETA_BITS  10
 
-/* Return integer component of theta */
+/** \return integer component of theta */
 static inline int __cfs_hash_theta_int(int theta)
 {
         return (theta >> CFS_HASH_THETA_BITS);
 }
 
-/* Return a fractional value between 0 and 999 */
+/** \return a fractional value between 0 and 999 */
 static inline int __cfs_hash_theta_frac(int theta)
 {
         return ((theta * 1000) >> CFS_HASH_THETA_BITS) -
@@ -364,11 +473,22 @@ static inline void __cfs_hash_set_theta(
         hs->hs_max_theta = max;
 }
 
-/* Generic debug formatting routines mainly for proc handler */
+/**
+ *\defgroup hash_debug Hash debug functions
+ *
+ * Generic debug formatting routines mainly for proc handler
+ * @{
+ */
 int cfs_hash_debug_header(char *str, int size);
 int cfs_hash_debug_str(cfs_hash_t *hs, char *str, int size);
+/** @} */
 
-/*
+/**
+ *\defgroup hash_algs Generic hash algorithms
+ * @{
+ */
+
+/**
  * Generic djb2 hash algorithm for character arrays.
  */
 static inline unsigned
@@ -384,7 +504,7 @@ cfs_hash_djb2_hash(void *key, size_t siz
         return (hash & mask);
 }
 
-/*
+/**
  * Generic u32 hash algorithm.
  */
 static inline unsigned
@@ -393,7 +513,7 @@ cfs_hash_u32_hash(__u32 key, unsigned ma
         return ((key * CFS_GOLDEN_RATIO_PRIME_32) & mask);
 }
 
-/*
+/**
  * Generic u64 hash algorithm.
  */
 static inline unsigned
@@ -401,6 +521,7 @@ cfs_hash_u64_hash(__u64 key, unsigned ma
 {
         return ((unsigned)(key * CFS_GOLDEN_RATIO_PRIME_64) & mask);
 }
+/** @} hash_algs */
 
 #define cfs_hash_for_each_bucket(hs, hsb, pos)   \
         for (pos = 0;                            \
@@ -408,5 +529,8 @@ cfs_hash_u64_hash(__u64 key, unsigned ma
              ({ hsb = hs->hs_buckets[i]; 1; });  \
              pos++)
 
+/** @} hash_table */
+/** @} libcfs */
+
 /* !__LIBCFS__HASH_H__ */
 #endif
Index: libcfs/include/libcfs/libcfs_ioctl.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_ioctl.h,v
retrieving revision 1.3
diff -u -p -r1.3 libcfs_ioctl.h
--- libcfs/include/libcfs/libcfs_ioctl.h	7 Aug 2008 14:48:45 -0000	1.3
+++ libcfs/include/libcfs/libcfs_ioctl.h	1 Jan 2010 20:03:32 -0000
@@ -43,40 +43,72 @@
 #ifndef __LIBCFS_IOCTL_H__
 #define __LIBCFS_IOCTL_H__
 
+/** \addtogroup libcfs
+ * @{
+ * \addtogroup libcfs_ioctl
+ * @{ */
 
+/** Libcfs magic for sanity checks of \a libcfs_ioctl_data */
 #define LIBCFS_IOCTL_VERSION 0x0001000a
 
+/**
+ * Format of ioctl data that user-space ioctl callers and in-kernel
+ * ioctl handlers must share.
+ *
+ * It's actually the head of ioctl data. The whole payload looks like this:
+ * - \a libcfs_ioctl_data
+ * - the first inline buffer of \a ioc_inllen1 bytes (must be zero-terminated)
+ * - the second inline buffer of \a ioc_inllen2 bytes (must be zero-terminated)
+ */
 struct libcfs_ioctl_data {
+        /** total length of payload including inline buffers */
         __u32 ioc_len;
+        /** LIBCFS_IOCTL_VERSION magic */
         __u32 ioc_version;
 
+        /** any 8-bytes value */
         __u64 ioc_nid;
+        /** any 8-bytes value */
         __u64 ioc_u64[1];
 
+        /** any 4-bytes value */
         __u32 ioc_flags;
+        /** any 4-bytes value */
         __u32 ioc_count;
+        /** any 4-bytes value */
         __u32 ioc_net;
+        /** any seven 4-bytes values */
         __u32 ioc_u32[7];
 
+        /** size of the first inline buffer */
         __u32 ioc_inllen1;
+        /** pointer to the first inline buffer */
         char *ioc_inlbuf1;
+        /** size of the second inline buffer */
         __u32 ioc_inllen2;
+        /** pointer to the second inline buffer */
         char *ioc_inlbuf2;
 
-        __u32 ioc_plen1; /* buffers in userspace */
+        /** size of the first user-space buffer */
+        __u32 ioc_plen1;
+        /** pointer to the first user-space buffer */
         char *ioc_pbuf1;
-        __u32 ioc_plen2; /* buffers in userspace */
+        /** size of the second user-space buffer */
+        __u32 ioc_plen2;
+        /** pointer to the second user-space buffer */
         char *ioc_pbuf2;
 
+        /** the first inline buffer may start here */
         char ioc_bulk[0];
 };
 
-
+/** duplicates the head of \a libcfs_ioctl_data */
 struct libcfs_ioctl_hdr {
         __u32 ioc_len;
         __u32 ioc_version;
 };
 
+/** format of ioctl data for ioctl(LIBCFS_IOC_DEBUG_MASK) */
 struct libcfs_debug_ioctl_data
 {
         struct libcfs_ioctl_hdr hdr;
@@ -84,6 +116,7 @@ struct libcfs_debug_ioctl_data
         unsigned int debug;
 };
 
+/** helper for initializing \a libcfs_ioctl_data in user-space */
 #define LIBCFS_IOC_INIT(data)                           \
 do {                                                    \
         memset(&data, 0, sizeof(data));                 \
@@ -93,11 +126,16 @@ do {                                    
 
 #ifdef __KERNEL__
 
+/** wrapper over ioctl handler that any in-kernel consumer of Libcfs
+ * should use to register some ioctl handler in Libcfs */
 struct libcfs_ioctl_handler {
+        /** list node to be element of global ioctl_list */
         struct list_head item;
+        /** consumer-defined ioctl handler */
         int (*handle_ioctl)(unsigned int cmd, struct libcfs_ioctl_data *data);
 };
 
+/** shortcut to declare and initialize \a libcfs_ioctl_handler in one line */
 #define DECLARE_IOCTL_HANDLER(ident, func)                      \
         struct libcfs_ioctl_handler ident = {                   \
                 /* .item = */ CFS_LIST_HEAD_INIT(ident.item),   \
@@ -226,4 +264,7 @@ extern int libcfs_ioctl_popdata(void *ar
 
 #endif 
 
+/** @} libcfs_ioctl */
+/** @} libcfs */
+
 #endif /* __LIBCFS_IOCTL_H__ */
Index: libcfs/include/libcfs/libcfs_kernelcomm.h
===================================================================
RCS file: /cvsroot/cfs/libcfs/include/libcfs/libcfs_kernelcomm.h,v
retrieving revision 1.2
diff -u -p -r1.2 libcfs_kernelcomm.h
--- libcfs/include/libcfs/libcfs_kernelcomm.h	19 Sep 2009 18:36:17 -0000	1.2
+++ libcfs/include/libcfs/libcfs_kernelcomm.h	1 Jan 2010 20:03:32 -0000
@@ -51,23 +51,48 @@
 #error Do not #include this file directly. #include <libcfs/libcfs.h> instead
 #endif
 
-/* LNL message header.
+/** \addtogroup libcfs
+ * @{ */
+
+/**
+ * \defgroup libcfs_lnl Kernel <-> user-space communication
+ * Kernel <-> user-space communication routines.
+ *
+ * We'll use a shorthand term "lnl" (Lustre NetLink) for this interface name
+ * for all arches, even though an implementation may not use NetLink.
+ *
+ * The definitions below are used in the kernel and user-space.
+ * @{ */
+
+/**
+ * LNL message header.
  * All current and future LNL messages should use this header.
  * To avoid having to include Lustre headers from libcfs, define this here.
  */
 struct lnl_hdr {
+        /** magic value for sanity checks */
         __u16 lnl_magic;
-        __u8  lnl_transport;  /* Each new Lustre feature should use a different
-                                 transport */
+        /** Each new Lustre feature should use a different transport */
+        __u8  lnl_transport;  
+        /** block/non-block behavior */                        
         __u8  lnl_flags;
-        __u16 lnl_msgtype;    /* Message type or opcode, transport-specific */
+        /** Message type or opcode, transport-specific */
+        __u16 lnl_msgtype;
+        /** total length of LNL message including this header */
         __u16 lnl_msglen;
 } __attribute__((aligned(sizeof(__u64))));
 
-#define LNL_MAGIC  0x191C /*Lustre9etLinC */
-#define LNL_FL_BLOCK 0x01   /* Wait for send */
+/** Lustre9etLinC. Used for lnl_hdr::lnl_magic. */
+#define LNL_MAGIC  0x191C 
+
+/** Wait for send. Used for lnl_hdr::lnl_flags. */
+#define LNL_FL_BLOCK 0x01
 
-/* lnl_msgtype values are defined in each transport */
+/**
+ * Enumerates all known transports. See description of lnl_hdr::lnl_transport.
+ *
+ * lnl_msgtype values are defined in each transport
+ */
 enum lnl_transport_type {
         LNL_TRANSPORT_GENERIC   = 1,
         LNL_TRANSPORT_HSM       = 2,
@@ -84,10 +109,14 @@ enum lnl_generic_message_type {
  * groups need not be used if e.g. a PID is specified instead;
  * use group 0 to signify unicast.
  */
+/** broadcast group for HSM */
 #define LNL_GRP_HSM           0x02
+/** total number of supported broadcast groups */
 #define LNL_GRP_CNT              2
 
-
+/** \defgroup libcfs_kernel_lnl Kernel <-> user-space communication (kernel)
+ * Kernel side of kernel <-> user-space communication subsystem.
+ * @{ */
 #if defined(HAVE_NETLINK) && defined (__KERNEL__)
 extern int libcfs_klnl_start(int transport);
 extern int libcfs_klnl_stop(int transport, int group);
@@ -103,8 +132,9 @@ static inline int libcfs_klnl_msg_put(in
         return -ENOSYS;
 }
 #endif
+/** @} libcfs_kernel_lnl */
 
-/*
+/**
  * NetLink socket number, see include/linux/netlink.h
  * All LNL users share a single netlink socket.  This actually is NetLink
  * specific, but is not to be used outside of the Linux implementation
@@ -112,6 +142,8 @@ static inline int libcfs_klnl_msg_put(in
  */
 #define LNL_SOCKET 26
 
+/** @} libcfs_lnl */
+/** @} libcfs */
 
 #endif /* __LIBCFS_KERNELCOMM_H__ */
 
